
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "ILog.h"
#include "OLog.h"
#include "IcpStat.h"


IcpStat::IcpStat() {
	reset();
}

void IcpStat::reset() {
	theStat.reset();
	theToutCnt = 0;
}

OLog &IcpStat::store(OLog &log) const {
	return log << theStat << theToutCnt;
}

ILog &IcpStat::load(ILog &log) {
	return log >> theStat >> theToutCnt;
}

IcpStat &IcpStat::operator +=(const IcpStat &ts) {
	theStat += ts.theStat;
	theToutCnt += ts.theToutCnt;
	return *this;
}

ostream &IcpStat::print(ostream &os, const String &pfx) const {
	theStat.print(os, "hit", "miss", pfx);
	os << pfx << "timeout.count:\t " << theToutCnt << endl;
	return os;
}
