
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_LOG_OBJECT_CLASS_H
#define PG_LOG_OBJECT_CLASS_H

// an optional parent of logged objects

class OLog;
class ILog;

struct LogObj {
	virtual ~LogObj() {}
	virtual OLog &store(OLog &ol) const = 0;
	virtual ILog &load(ILog &il) = 0;
};

inline OLog &operator <<(OLog &log, const LogObj &o) { o.store(log); return log; }
inline ILog &operator >>(ILog &log, LogObj &o) { o.load(log); return log; }


#endif
