
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "Clock.h"
#include "OLog.h"
#include "ILog.h"
#include "Progress.h"

Progress TheProgress;


Progress::Progress() {
	theXactCnt = theErrCnt = 0;
}

Time Progress::time() const {
	return theTimestamp < 0 ? TheClock.time() : theTimestamp;
}

void Progress::store(OLog &ol) const {
	ol << TheClock.time() << theXactCnt << theErrCnt;
}

void Progress::load(ILog &il) {
	il >> theTimestamp >> theXactCnt >> theErrCnt;
}

ostream &Progress::print(ostream &os) const {
	os << theXactCnt << ':';
	if (theTimestamp < 0)
		os << (TheClock - Clock::TheStartTime);
	else
		os << (theTimestamp - Clock::TheStartTime);
	return os << ':' << theErrCnt;
}
