
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "CltOpts.h"

#include "runtime/globals.h"


CltOpts TheCltOpts;


CltOpts::CltOpts():
	thePxyAddr(this,        "proxy <host:port>",   "proxy location", NetAddr()),

	thePorts(this,          "ports <port_range>",  "port range for explicit binding"),

	theIcpTout(this,        "icp_tout <time>",     "how long to wait for an ICP_HIT reply", Time::Sec(2)),

	theNidsPrefDepth(this,  "new_oids_prefetch <int>", "how many new oids to prefetch", 128),

	ignoreFalseHits(this,   "ign_false_hits <bool>","ignore false hits", true),
	printFalseMisses(this,  "prn_false_misses <bool>","dump rep headers of false misses")
{
}

bool CltOpts::validate() const {
	if (theNidsPrefDepth <= 0)
		cerr << ThePrgName << ": new oids prefetch depth must be positive, got: " << theNidsPrefDepth << endl;
	else
		return OptGrp::validate();
	return false;
}
