
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_ICP_CLIENT_H
#define PG_ICP_CLIENT_H

#include "Array.h"
#include "IcpBase.h"

class IcpCltRes {
	public:
		IcpCltRes(int anIdx = -1): theIdx(anIdx) {}

		void reset() { theIdx = -1; }

		operator void*() const { return theIdx >= 0 ? (void*)-1 : 0; }
		int reqNum() const { return theIdx; }

	protected:
		int theIdx;
};

class IcpCltUser {
	public:
		virtual ~IcpCltUser();
		virtual void reset();

		virtual const ObjId &oid() const = 0;
		virtual void noteReply(const IcpMsg &r) = 0;

	protected:
		IcpCltRes theReserv;
};

// matches ICP requests and responses
class IcpClient: virtual public IcpBase {
	public:
		IcpClient();

		IcpCltRes expectReply(IcpCltUser *u);
		void cancel(const IcpCltRes &res);

	protected:
		virtual void noteReply(const IcpMsg &m);

	protected:
		Array<IcpCltUser*> theUsers;
		int theLastReqNum;
};

#endif
