
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "Cache.h"
#include "IcpMsg.h"
#include "IcpServer.h"


IcpServer::IcpServer(): theCache(0) {
}

void IcpServer::cache(Cache *aCache) {
	Assert(!theCache);
	theCache = aCache;
}

void IcpServer::noteRequest(const IcpMsg &m) {
	IcpMsg r(m); // is it ok to reuse all parts?
	if (theCache)
		r.opCode(theCache->cached(m.oid()) ? icpHit : icpMissNoFetch);
	else
		r.opCode(icpDenied);
	r.send(theSock);
}
