
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "pgl.h"

#include "String.h"
#include "PglRec.h"
#include "DumperSym.h"


DumperSym::DumperSym(): RecSym("Dumper", new PglRec) {

	// add fields

	theRec->bAdd("bool", "req_hdrs", 0);
	theRec->bAdd("bool", "rep_hdrs", 0);
}

DumperSym::DumperSym(const String &aType, PglRec *aRec): RecSym(aType, aRec) {
	// find fields
}

bool DumperSym::isA(const String &type) const {
	return RecSym::isA(type) || type == "Dumper";
}

SynSym *DumperSym::clone(const String &type) const {
	if (isA(type))
		return new DumperSym(this->type(), theRec->clone());
	return RecSym::clone(type);
}
