
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_BANDWIDTH_SYMBOL_H
#define PGL_BANDWIDTH_SYMBOL_H

#include "Time.h"
#include "BigSize.h"
#include "PglExprSym.h"

class TimeSym;
class SizeSym;
class NumSym;

typedef double Bwidth;  // for now
extern Bwidth Bandwidth(BigSize sz, Time tm);
inline double BytesPerSec(Bwidth bw) { return bw; }
inline double BitsPerSec(Bwidth bw) { return 8*BytesPerSec(bw); }


// bandwidth [size/time]

class BwidthSym: public ExpressionSym {
	public:
		BwidthSym(BigSize aSize, Time anInterval);
		BwidthSym(Bwidth aVal);

		Bwidth val() const;
		void val(Bwidth aVal);

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ExpressionSym *unOper(const String &op) const;
		virtual ExpressionSym *bnOper(const String &op, const SynSym &exp) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		ExpressionSym *operBB(const String &op, BwidthSym *rs, const SynSym &s) const;
		ExpressionSym *operBT(const String &op, TimeSym *ts, const SynSym &s) const;
		ExpressionSym *operBN(const String &op, NumSym *ns, const SynSym &s) const;

	protected:
		Bwidth theVal;
};




#endif
