
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_LIST_SYMBOL_H
#define PGL_LIST_SYMBOL_H

#include "Array.h"
#include "pglSyms.h"

// list of symbols of a any types
class ListSym: protected Array<SynSym*>, public ExpressionSym {
	public:
		ListSym(const String &aType = "List");
		virtual ~ListSym();

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		int count() const { return Array<SynSym*>::count(); }
		const SynSym *operator [](int idx) const { return this->item(idx); }

		void add(const SynSym &s);

		virtual ostream &print(ostream &os, const String &pfx) const;

	protected:
		bool absorb(const ListSym &arr);
		void doAdd(SynSym *sclone, const SynSym &s);

		virtual void addFailure(const SynSym &s);
		virtual bool cadd(const SynSym &s);
};

#endif
