
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_NET_ADDRESS_RANGE_H
#define PGL_NET_ADDRESS_RANGE_H

#include "Array.h"

class String;
class ArraySym;

class PglNetAddrRange {
	protected:
		struct Block { 
			int min, max;
			int pos;

			Block();
			bool valid() const;
		};

	public:
		PglNetAddrRange();
		~PglNetAddrRange();

		// use subnet specs or guess an approprite netmask for the range
		void netmask(struct in_addr &pin) const;

		ArraySym *toSyms();
		void toAddrs(Array<NetAddr*> &addrs);
		bool parse(const String &val);
		
	protected:
		void startIter();
		bool nextIter();
		bool nextIter(int level);
		void currentIterAddr(String &str);
		
		bool parseBlock(const String &val);
		
	protected:
		Array<Block> theBlocks; // address octet specs
		int theSubnet;          // optiona subnet specs
		int thePort;            // one for all, if any
		int theRangeCnt;        // number of blocks specified using a range
		int theSpillCnt;        // number of blocks spanning class-X boundaries

	private:
		Array<String*> theStrs; // temporary storage for parsing
	
};

#endif
