
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PGL_RECORD_SYMBOL_H
#define PGL_RECORD_SYMBOL_H

#include "Time.h"
#include "NetAddr.h"
#include "PglBwidthSym.h"
#include "PglExprSym.h"

class BigSize;
class String;
class RndDistr;
class PglRec;
class ArraySym;

class RecSym: public ExpressionSym {
	public:
		typedef PglRec Rec;

	public:
		RecSym(const String &aType, Rec *aRec): ExpressionSym(aType), theRec(aRec) {}
		virtual ~RecSym();

		Rec *rec() { return theRec; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		bool getBool(const String &name, bool &set) const;
		bool getInt(const String &name, int &n) const;
		bool getDouble(const String &name, double &n) const;
		bool getSize(const String &name, BigSize &sz) const;
		bool getBwidth(const String &name, Bwidth &bw) const;
		Time getTime(const String &name) const;
		RndDistr *getDistr(const String &name) const;
		String getString(const String &name) const;
		NetAddr getNetAddr(const String &name) const;
		ArraySym *getArraySym(const String &name) const;

	protected:
		Rec *theRec;
};

#endif
