
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "base/polygraph.h"

#include <iomanip.h>

#include "xstd/Rnd.h"
#include "base/RndPermut.h"
#include "runtime/HotSet.h"


HotSet::HotSet(): thePos(0), theObjLmt(0) {
}

int HotSet::position(int objCnt, int wss) {
	// is it time to change the position
	if (objCnt && objCnt >= theObjLmt) {
		if (wss < 0)
			wss = objCnt;
		RndGen rng(RndPermut(thePos, rndHotSetPos));
		thePos = objCnt - rng(0, wss);
		theObjLmt = objCnt + wss;
		/*clog << here << this << ": jump to " << setw(6) << thePos
			<< " wss: " << setw(6) << wss 
			<< " objs: " << setw(6) << objCnt
			<< " lmt: " << theObjLmt
			<< endl;*/
	}
	return thePos;
}
