
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_STAT_PHASE_MANAGER_H
#define PG_STAT_PHASE_MANAGER_H

#include "Array.h"
#include "runtime/StatIntvl.h"

class StatPhase;

// iterates through stat phases
// flushes all sats and terminates program when the last phase is over
class StatPhaseMgr {
	public:
		StatPhaseMgr();
		~StatPhaseMgr();

		void addPhase(StatPhase *ph);
		void start();

		StatPhase *operator ->() { return thePhase; }

		void forceFlush();
		void noteDone(StatPhase *ph);

		void reportCfg(ostream &os) const;

	protected:
		void nextPhase();

	protected:
		Array <StatPhase*> thePhases; // all phases are stored here
		StatPhase *thePhase; // current phase, thePhases[thePhaseIdx]
		int thePhaseIdx;
};

#endif
