
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include "String.h"
#include "base/ErrorStrTbl.h"
#include "polyErrors.h"

struct PolyErrorStrTbl: public ErrorStrTbl {
	PolyErrorStrTbl();
};

PolyErrorStrTbl ThePolyErrorStrTbl;

PolyErrorStrTbl::PolyErrorStrTbl() {
	str(errForeignReq)    = "foreign HTTP request";
	str(errForeignRep)    = "foreign HTTP reply";
	str(errIcpForeignReq) = "foreign ICP request";
	str(errIcpForeignRep) = "foreign ICP reply";
	str(errMisdirRequest) = "misdirected request";
	str(errForeignHostName)= "foreign host name";
	str(errBadHostName)   = "failed to parse host name";
	str(errPrematureEof)  = "premature end of msg body";
	str(errPrematureEoh)  = "premature end of msg header";
	str(errExtraRepData)  = "extra reply data";
	str(errNoHdrClose)    = "connection closed before sending headers";
	str(errHttpStatusCode)= "unsupported HTTP status code";
	str(errNoCLen)        = "missing Content-Length header";
	str(errUnexpectedCLen)= "unexpected Content-Length header";
	str(errHttpNoDate)    = "missing Date: header field";
	str(errSyncDate)      = "clocks out of sync";
	str(errHugeHdr)       = "HTTP header is too big";
	str(errUnchbHit)      = "hit on uncachable object";
	str(err1UseHit)       = "hit on first request to an object";
	str(errReloadHit)     = "hit on reload request";
	str(errStaleHit)      = "stale object";
	str(errZeroFDLimit)   = "zero filedescriptor limit?!";
	str(errChbChange)     = "cachability status changed";
	str(errFalseHit)      = "false hit";
	str(errServerGone)    = "server had to terminate";
	str(errLogBufFull)    = "log buffer is full";
	str(errUnclaimOid)    = "a server-advertised oid has not been requested for a while";
	str(errUnsolicOid)    = "a non-server-advertised oid has been requested";
	str(errNoNewOids)     = "client ran out of new public oids";
	str(errFidFlood)      = "cannot send failed oids to servers fast enough";
	str(errNidReqFlood)   = "server received too many requests for new oids";
	str(errNidRepFlood)   = "client received too many new oids";
	str(errNidMapLimit)   = "server new oid map cannot grow any more";
	str(errSrvChangedWid) = "client discovered server world id change";
	str(errUnused1)       = "this error code is not used";
	str(errForeignTag)    = "foregn content <tag>";
	str(errMalformedTag)  = "malformed content <tag>";
	str(errOpenTag)       = "open content <tag"; // vs. unbalanced
	str(errTooManyWaitXact)= "too many postponed xactions";
	str(errTimingDrift)   = "internal timers may be getting behind";
	str(errSiblingViolation) = "violation of a sibling relationship";
	str(errIcpRepCode)    = "unsupported ICP opcode";
	str(errIcpVersion)    = "unsupported ICP version";
	str(errIcpMsgSize)    = "bad ICP message size";
	str(errIcpBadReqNum)  = "bad ICP reqnum";
	str(errIcpRepOverlap) = "ICP client may have too many outstanding requests";
	str(errIcpUnexpMsg)   = "unexpected message to an ICP agent";
	str(errIcpErrOpcode)  = "got ICP reply with ICP_ERROR opcode";

	str(errOther) = "unclassified error";

	// check that all are defined
	for (int i = errStart+1; i < errEnd; ++i)
		Assert(item(i) && *item(i));
}

const ErrorStrTbl *polyErrorStrTbl() {
	return &ThePolyErrorStrTbl;	
}
