
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#ifndef PG_POLY_ERRORS_H
#define PG_POLY_ERRORS_H

class ErrorStrTbl;
extern const ErrorStrTbl *polyErrorStrTbl();

enum PolyErrors {
	errNone = 0,
	errStart = 255,  // assume all "system" errors have lower numbers
	errForeignReq,
	errForeignRep,
	errIcpForeignReq,
	errIcpForeignRep,
	errMisdirRequest,
	errForeignHostName,
	errBadHostName,
	errPrematureEof,
	errPrematureEoh,
	errExtraRepData,
	errHttpStatusCode,
	errNoHdrClose,
	errNoCLen,
	errUnexpectedCLen,
	errHttpNoDate,
	errSyncDate,
	errHugeHdr,
	errUnchbHit,
	err1UseHit,
	errReloadHit,
	errStaleHit,
	errZeroFDLimit,
	errChbChange,
	errFalseHit,
	errServerGone,
	errLogBufFull,
	errUnclaimOid,
	errUnsolicOid,
	errNoNewOids,
	errFidFlood,
	errNidReqFlood,
	errNidRepFlood,
	errNidMapLimit,
	errSrvChangedWid,
	errUnused1,	// errWrongContentId,
	errForeignTag,
	errMalformedTag,
	errOpenTag, // vs. unbalanced
	errTooManyWaitXact,
	errTimingDrift,
	errSiblingViolation,
	errIcpRepCode,
	errIcpVersion,
	errIcpMsgSize,
	errIcpBadReqNum,
	errIcpRepOverlap,
	errIcpUnexpMsg,
	errIcpErrOpcode,

	errOther,

	errEnd
};

#endif
