
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "polygraph.h"

#include <iostream.h>
#include <iomanip.h>

#include "Server.h"
#include "base/OLog.h"
#include "runtime/LogComment.h"
#include "runtime/SharedOpts.h"
#include "SrvOpts.h"
#include "runtime/StatIntvl.h"
#include "PolySrv.h"

#include "ServerSym.h"

#include "polyLogCats.h"
#include "gadgets.h"
#include "runtime/globals.h"

typedef XactFarmT<SrvXact, SrvXact> SrvXactFarm;


PolySrv::PolySrv() {
	theAgentType = "Server";
}

void PolySrv::makeAgent(const AgentCfg &cfg) {
	Assert(cfg.sym);
	
	const ServerSym *scfg = &(const ServerSym&)cfg.sym->cast("Server");
	Server *server = new Server();
	server->configure(scfg, *cfg.host, agentMustBind);
	
	addAgent(server);
}

void PolySrv::configure() {
	PolyApp::configure();
	Server::Farm(new SrvXactFarm);
	StatIntvl::ActiveCat(lgcSrvSide);
	StatIntvl::TheReportCat = lgcSrvSide;
}

void PolySrv::getOpts(Array<OptGrp*> &opts) {
	PolyApp::getOpts(opts);
	opts.append(&TheSrvOpts);
}

void PolySrv::logState(OLog &log) {
	PolyApp::logState(log);
}


int main(int argc, char *argv[]) {
	PolySrv app;
	return app.run(argc, argv);
}
