
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xparser.h"

#include "LexToken.h"


/* LexTokenChar */

LexTokenChar::LexTokenChar(): ch(0), isFirstOnLine(false) {
}


/* LexToken */

void LexToken::reset() {
	theId = -1;
	theSpell = 0;
	isFirstOnLine = false;
}

void LexToken::addChar(char c) {
	if (theSpell.len() < 4096)
		theSpell += c;
	else
		cerr << theLoc << "input token is already " << theSpell.len() << " characters long" << endl << xexit;
}

LexToken &LexToken::operator +=(const LexTokenChar &c) {
	addChar(c.ch);
	isFirstOnLine = c.isFirstOnLine;
	return *this;
}

void LexToken::trim(char c) {
	// ltrim
	int i = 0;
	while (i < theSpell.len() && theSpell[i] == c) ++i;

	// rtrim
	int j = theSpell.len() - 1;
	while (j > 0 && theSpell[j-1] == c) --j;
	
	if (j > i)
		theSpell = theSpell(i, j);
	else
		theSpell = "";
}
