
/*
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1998-2000 by The Regents of the
 *  University of California. All rights reserved. See the COPYRIGHT
 *  file for details.
 *
 */

#include "xstd.h"

#include <sys/param.h>  /* for BSD4_4 to be defined */
#include <unistd.h>

#include "fixResourceUsage.h"

Size MaxRss2Size(long maxrss) {
	int kb = -1;
	// some platforms define maxrss in KBytes, some in pages
#if defined(CFG_HOS_SGI)
	kb = maxrss;
#elif defined(CFG_HOS_OSF)
	kb = maxrss;
#elif defined(BSD4_4)
	kb = maxrss;
#elif defined(HAVE_GETPAGESIZE)
	kb = (maxrss * ::getpagesize()) / 1024;
#elif defined(PAGESIZE)
	kb = (maxrss * PAGESIZE) / 1024;
#else
	kb = maxrss;
#endif

	return Size::KB(kb);
}
